

#include "processor.inc"
#include "autop_defines.inc"

	EXTERN	MULS2X1 , MULU2X1 , MULS2X2 , filter

PROG1 	CODE


elev_cntrl

	bcf		ELE_req

;	get the filtered pitch rate gyro
	movff	pitchU , ARG1H
	movff	pitchH , ARG1L

;	subtract the baseline pitch
	movf	pitch0H , w
	subwf	ARG1L , f
	movf	pitch0U , w
	subwfb	ARG1H , f

;	add the baseline reference
	movf	ref0H , w
	addwf	ARG1L , f
	movf	ref0U , w
	addwfc	ARG1H , f

;	subtract the reference voltage
	movf	refH , w
	subwf	ARG1L , f
	movf	refU , w
	subwfb	ARG1H , f


;	multiply by the pitch gyro gain
	movff	pitchgain , ARG2L
	call	MULS2X1


;#ifdef	sf2520v1
;	doubleres
;	doubleres
;#endif

;	load into the elevator 3 byte accumulator
	movff	RES0 , elevL
	movff	RES1 , elevH
	movff	RES2 , elevU

;	get the y axis accleration, along the fuselage axis
	movff	yaccelU , ARG1H
	movff	yaccelH , ARG1L

;	subtract the accelerometer baseline
	movf	yaccel0H , w
	subwf	ARG1L , f
	movf	yaccel0U , w
	subwfb	ARG1H , f

;	multiply by the accelerometer gain
	movff	accelgain , ARG2L
	call	MULS2X1

;	add into the elevator accumulator
	movf	RES0 , W
	addwf	elevL , F
	movf	RES1 , W
	addwfc	elevH , F
	movf	RES2 , W
	addwfc	elevU , F

;	compute the pitch rate due to turning

;	get the yaw rate and subtract reference and offset
	movff	yawunfH , ARG1H
	movff	yawunfL , ARG1L	

;	subtract the baseline yaw
	movf	yaw0H , w
	subwf	ARG1L , f
	movf	yaw0U , w
	subwfb	ARG1H , f

;	add the baseline reference
	movf	ref0H , w
	addwf	ARG1L , f
	movf	ref0U , w
	addwfc	ARG1H , f

;	subtract the reference
	movf	refH , w
	subwf	ARG1L , f
	movf	refU , w
	subwfb	ARG1H , f

	movff	ARG1L , yawadjL
	movff	ARG1H , yawadjH

	movff	yawfilU , ARG2H
	movff	yawfilH , ARG2L


;	multiply filtered by unfiltered

	call	MULS2X2

;	filter it once

	movff	yawsqU , outfilU
	movff	yawsqH , outfilH
	movff	yawsqL , outfilL
	movff	RES1 , infilL
	movff	RES2 , infilH
	movlw	.1
	movwf	taufil
	call	filter
	movff	outfilL , yawsqL
	movff	outfilH , yawsqH
	movff	outfilU , yawsqU

;	multiply by gyro mix gain

	movff	yawsqU , ARG1H
	movff	yawsqH , ARG1L

	movff	mixgyr , ARG2L
	call	MULS2X1

;#ifdef	sf2520v1
;	doubleres
;	doubleres
;#endif

	movf	RES0 , W
	addwf	elevL , F
	movf	RES1 , W
	addwfc	elevH , F	
	movf	RES2 , W
	addwfc	elevU , F

;	compute mixing of rudder into elevator
	movf	PWM1_dc , W
;	btg		WREG , 7
	movff	strngTrim , strngTrimTemp
	subwf	strngTrimTemp , F
	bov		mixinover

squareRudd
	movff	strngTrimTemp , ruddunfL
	clrf	ruddunfH
	btfsc	strngTrimTemp , 7
	comf	ruddunfH , f

	smult	ruddfilH , strngTrimTemp
	movff	PRODL , ARG1L
	movff	PRODH , ARG1H

;	multiply by mixing gain and add into the total
	movff	mixgain , ARG2L
	call	MULS2X1
	movf	RES1 , W
	addwf	elevL , F
	movf	RES2 , W
	addwfc	elevH , F
	movlw	0x00
	btfsc	RES2 , 7
	movlw	0xFF
	addwfc	elevU , F


;	convert into a servo time period offset
	movlw	0x08
	addwf	elevH , F
	movlw	0x00
	addwfc	elevU , F

;	check for time period overflow in upper byte
	movf	elevU , w
	andlw	0xFF
	bz		elevU_normal
	bn		elev_min
	movlw	0xFF
	bra		elev_trm_adjst

mixinover
	movlw	0xFF
	movwf	strngTrimTemp
	bra		squareRudd

elevU_normal

;	check for time period overflow in high byte
	movf	elevH, W				;	retrieve MSbyte of result
	andlw	0xF0					;	check for overflow
	bz		elev_normal			;	no "clamping" needed
	bn		elev_min				;	clamp to minimum for a "negative" time width pulse
	movlw	0xFF
	bra		elev_trm_adjst
elev_min
	clrf	WREG
	bra		elev_trm_adjst
elev_normal						;	unclamped case, must shift by 4 bits by using "swap:
	movlw	0xF0					;	mask for upper 4 bits
	andwf	elevL, W				;	get the upper 4 bits of elevL, put in W
	iorwf	elevH, W				;	"or" the lower 4 bits of elevH into W
									;	At this point the result is in W, except the nibbles are swapped.
	swapf	WREG					;	Swap the nibbles for the 4 bit shift.
;
;	here is where the trim comes in.
;	add the trim, test for overflow.
;
elev_trm_adjst
;
;	convert time period back to an angle
	btg		WREG , 7
;
;	get the trim time period, convert to an angle
	movff	pwelein , speedTrimTemp
	btg		speedTrimTemp , 7
;
;	add the trim
	addwf	speedTrimTemp , W
;
;	check for overflow
	bov		elevtrim_ov
;
;	convert back to a time period and set pwm duty cycle
	btg		WREG , 7
	movwf	PWM2_dc					;	Move the intermediate result to its final destination.
	return

elevtrim_ov
	btfss	WREG , 7
	bra		elev_clamp_min
	bra		elev_clamp_max
elev_clamp_max
	movlw	0xFF					;	otherwise, clamp to maximum, if overflow and not negative
	movwf	PWM2_dc					;	result is the PWM duty cycle
	return
elev_clamp_min
	movlw	0x00					;	clamp to minimum, result is PWM duty cycle
	movwf	PWM2_dc
	return

	GLOBAL elev_cntrl 

	end
