
#include "processor.inc"
#include "autop_defines.inc"


PROG1 	CODE

	EXTERN	rect_to_polar, MULS2X2

navigateBP


;	movlw	mediumSpeed				;	set the speed to medium forward
;	movwf	desiredSpeed


	;calc Dist1 and Angle1
	movff xWorldH,X_rectH
	movff xWorldL,X_rectL
	movff yWorldH,Y_rectH
	movff yWorldL,Y_rectL

	rcall rect_to_polar
	movff THETA,angle1
	movff X_rectL,dist1L
	movff X_rectH,dist1H
	


;calc Dist2 and Angle2
	movff xWorldH,X_rectH
	movff xWorldL,X_rectL
	movff yWorldH,Y_rectH
	movff yWorldL,Y_rectL
	movf xFocusL,w
	subwf X_rectL,f
	movf xFocusH,w
	subwfb X_rectH,f
	movf yFocusL,w
	subwf Y_rectL,f
	movf yFocusH,w
	subwfb Y_rectH,f

	rcall rect_to_polar
	movff THETA,angle2
	movff X_rectL,dist2L
	movff X_rectH,dist2H 
	
	
	movf angle1,w
	subwf angle2,w
	btfss STATUS,C
	negf WREG
	movwf angleTang

;average Angle1 and angle2
	movf angle1,w
	addwf angle2,w
	rrcf WREG,w
	btfsc angleTang,7
	addlw .128
;	addlw 0x40		; old way, tangent angle
	addlw 0x80		; come home	angle, inward
	movwf angleTang


;Dist1+Dist2 -> dist1
	movf dist2L,w
	addwf dist1L,f
	movf dist2H,w
	addwfc dist1H,f


;dist1-EllipseConst -> dist1
	movf ellipseConstL,w
	subwf dist1L,f
	movf ellipseConstH,w
	subwfb dist1H,f

;dist1 * navGain -> w
	movff dist1H,ARG1H
	movff dist1L,ARG1L
	movlw navGain
	movwf ARG2L
	clrf ARG2H
	call MULS2X2

	movff RES1,dist1L
	movff RES2,dist1H


;test sign, negate dist1 if negative
	btfsc RES2,7
	rcall flip_sign
	
;goto Too_Big if greater than 64
	movf dist1H,w
	bnz Too_Big
	btfsc dist1L,7
	goto Too_Big
	btfsc dist1L,6
	goto Too_Big

	movf RES1,w
	goto Adjust_Angle


Too_Big
	movlw 0x40
	btfsc RES2,7
	negf WREG

Adjust_Angle
	addwf angleTang,w	; 	old way of navigating
	movwf desiredDir	;	add correction to average angle
	return

flip_sign
	comf dist1L
	comf dist1H
	movlw	.1
	addwf dist1L , f
	movlw	.0
	addwfc dist1H , f
	return

navigateAM
	return


	GLOBAL	navigateBP , navigateAM

	end	
