

#include "processor.inc"
#include "autop_defines.inc"

;********************************************************************************
;																				*
;	Steering module, executed 10 times per second to keep the vehicle			*
;	pointed in the desired direction, using a simple proportional control.		*
;	The servo angle is set proportional to the desired direction minus the		*
;	actual direction.															*
;																				*
;	All directions are measured as a 1 byte unsigned number, clockwise from		*
;	"north": 0 is N, 64 is E, 128 is S, and 192 is W.							*
;																				*
;	actualDir is updated from the compass 10 times per second.					*
;	desiredDir is determined by the navigation module from GPS info, once per	*
;	second. strngGain is the one byte steering gain, with an implied binary		*
;	point between the upper and lower 4 bits. In other words, a "engineering"	*
;	gain of one translates to a binary value of 0x10, or 16 decimal.			*
;	strngGain is an 8 bit signed number, so the feedback can be "flipped" if	*
;	need be. strngGain could also be set "on the fly".							*
;																				*
;********************************************************************************


PROG1 	CODE

	extern	ROTATE	;

SteerInit					

	movlw	steering_gain0		;	initialize steering gain
	movwf	strngGain

	movlw	0x80
	movwf	strngTrim
	movwf	elevTrim
	
	bsf		xaccel_dir
	bsf		yaccel_dir
	bsf		temp_dir
	bsf		vref_dir
	bsf		rate_dir

;	bcf		st3st1_dir
;	bcf		st2_dir

;	bcf		st3st1
;	bcf		st2
	

	return



	GLOBAL	SteerInit


	end
