;************************************************************************


#include "processor.inc"
#include "sf2520v1.inc"


#define	pwmin2_dir	TRISB,4
#define	pwmin2		PORTB_snap,4
#define pwmin2_xor	PORTB_xor,4

#define	pwmin1_dir	TRISB,5
#define	pwmin1		PORTB_snap,5
#define pwmin1_xor	PORTB_xor,5

#define	pwmin3r_dir	TRISB,1
#define	pwmin3r		PORTB,1

#define	pwmin3f_dir	TRISB,2
#define	pwmin3f		PORTB,2

#define	pwmout2_dir	TRISC,1
#define pwmout2		PORTC,1

#define	pwmout1_dir	TRISC,2
#define pwmout1		PORTC,2


VRBLS0		UDATA_ACS	

PORTB_snap		RES	1	;

STARTUP CODE
	NOP
	goto	start			;	reboot
	ORG	0x08
	goto	serv_inter_H	;	high priority interrupt
	ORG 0x18
	goto	serv_inter_L	;	low priority interrupt
	NOP

PROG1 	CODE



serv_PORTB
;	movff	TMR2, TMR2_snap		; snapshot timer 2
	bcf		INTCON, RBIF		; clear the interrupt
	btfss	INTCON, RBIE
	return

	movff	PORTB , PORTB_snap	; snapshot the B port

	btfss	pwmin1
	bcf		pwmout1

	btfsc	pwmin1
	bsf		pwmout1

	btfss	pwmin2
	bcf		pwmout2

	btfsc	pwmin2
	bsf		pwmout2

	return


serv_inter_H				;	high priority interrupt to measure PWM coming in



	btfsc	INTCON, RBIF
	rcall	serv_PORTB


	retfie	FAST			;		reenable (high priority) interrupts and restore context



serv_inter_L				;		low priority interrupt to handle PWM out and USART






;********************************************************************************
;																				*
;			TURN THE INTERRUPTS BACK ON!										*
;																				*
	bsf 	INTCON, GIEL		;	re-enable low priority interrupts
;																				*
;																				*
;********************************************************************************




	return




start
	movlw	0x01				;	setup the bank selection register for bank1 variables.
	movwf	BSR

;	Initialize all of the modules



;	Set the Input/Output direction on some of the pins,
;	and initialize them. debugA, B, and C are the debug LEDs.

	bcf		INTCON2, RBPU	; enable the pullup resistors on PORTB
		

	bcf		debugA_dir
	bcf		debugB_dir
	bcf		debugC_dir	; output
	bcf		debugC		; off
	bcf		debugB
	bcf		debugA

	bsf		pwmin1_dir	; input
	bsf		pwmin2_dir	; input

	bcf		pwmout2_dir	; output
	bcf		pwmout2		; off
	bcf		pwmout1_dir	; output
	bcf		pwmout1		; off

	bsf		pwmin3r_dir	; input
	bsf		pwmin3f_dir	; input

		
;	Setup the configuration bits for the interrupts

	bsf		RCON, IPEN		; enable high/low priority structure


	bsf		INTCON2, RBIP		; port b interrupt on value, high priority
	bcf		INTCON, RBIF		; clear any stale interrupt request, portb



;	bsf 	INTCON, GIEL	; enable low priority interrupts
	bsf		INTCON, GIEH	; enambe high priority interrupts

	bsf		INTCON, RBIE	; turn on the pass through servo interrupt

loop	goto	loop


	end	
